;++++++++++++++++++++++++++++++++++++++++++++++++++++
;+           BskV20_GroupR}h                   +
;+              SK_UtilFuncs.lsp                    +
;+ 2020-10-10:                                  +
;++++++++++++++++++++++++++++++++++++++++++++++++++++
;-------------------------------------------;
; ݂̼ѕϐۑ                      ;
;-------------------------------------------;
; -------- a:ѕϐؽ              ;
; ۰ٕϐ--- g_lstMode:ݒۑϐ ;
;-------------------------------------------;
(defun ModeSet (a)
	(setq g_lstMode '())
	(repeat (length a)
		(setq g_lstMode (append g_lstMode (list (list (car a) (getvar (car a))))))
		(setq a (cdr a))
	)
)

;-------------------------------------------;
; (ModeSet)ŕۑѕϐ𕜋A         ;
;-------------------------------------------;
; ۰ٕϐ--- g_lstMode:ݒۑϐ ;
;-------------------------------------------;
(defun ModeReset ()
	(repeat (length g_lstMode)
		(setvar (caar g_lstMode) (if (= (cadar g_lstMode) "") "." (cadar g_lstMode)))
		(setq g_lstMode (cdr g_lstMode))
	)
)

;Ō̴èè𓾂
(defun LastEntity ( / el en)
	(setq el (entlast))
	(if el (progn
		(while (setq en (entnext el))
			(setq el en)
		)
	);else
		(setq el nil)
	)
	el
)

;leȍ~ɕ`ꂽ}`Q𓾂
(defun Getss (le / en retss)
	(if le
		(setq en (entnext le))
	;else
		(setq en (entnext))
	)
	(if en (progn
		(setq retss (ssadd en))
		(setq le en)
		(while (setq en (entnext le))
			(ssadd en retss)
			(setq le en)
		)
		retss
	);else
		(setq retss nil)
	)
	retss
)

;ubN(NESTΉ)
(defun Explode_NestedBlk (enmBlk / el ssNew len i enmTmp entTmp typTmp)
	(setq el (LastEntity))
	(command ".EXPLODE" enmBlk)
	(if (setq ssNew (Getss el))(progn
		(setq len (sslength ssNew))
		(setq i 0)
		(repeat len
			(setq enmTmp (ssname ssNew i))
			(setq entTmp (entget enmTmp))
			(setq typTmp (cdr (assoc 0 entTmp)))
			(if (= typTmp "INSERT")
				(Explode_NestedBlk enmTmp) ;ċAďo
			)
			(setq i (1+ i))
		)
	))
	(princ)
)

; I}`Q𕪉
; ɑԂ
; ۯȽĂɑΉ
(defun Explodess (s1 / el n l e typ ret flag)
	(setq el (LastEntity))
	(setq n 0
		  l (sslength s1)
	)
	(repeat l
		(setq e   (ssname s1 n)
			  ent (entget e)
			  typ (cdr (assoc 0  ent))
		)
		(if (= typ "INSERT")(progn
			(setq flag t)
			(Explode_NestedBlk e);ۯ̕(NESTΉ)
		))
		(setq n (1+ n))
	)
	(setq ret (Getss el))
	ret
)

; ٰ߂ؽĂ쐬
(defun GetGroupList ()
	 (setq grp (dictsearch (namedobjdict) "ACAD_GROUP"))
	 (setq grpList (list))
	 (while (/= (assoc 3 grp) nil)
		 (setq grpList (cons (cdr (assoc 3 grp)) grpList ))
		 (setq grp (cdr (member (assoc 3 grp) grp)))
	 )
	 grpList
)

;}`ĂO[ṽXgԂ
(defun sk_getGName (en / ed gen lst_gname lst_group)
  (setq ed (entget en))
  (while (and (not gen) (setq ed (member (assoc 330 ed) ed)))
    (if (= "GROUP" (cdr (assoc 0 (entget (cdar ed)))))
      (setq gen (cdar ed))
    )
    (setq ed (cdr ed))
  )
  (if (and gen (setq lst_group (reverse (dictsearch (namedobjdict) "ACAD_GROUP"))))
    (while (setq lst_group (member (assoc 350 lst_group) lst_group))
      (if (member (cons 340 en) (entget (cdar lst_group)))
        (setq lst_gname (cons (cdadr lst_group) lst_gname))
      )
      (setq lst_group (cdr lst_group))
    )
  )
  lst_gname
)

;Xg̗vfŏ1폜
(defun RemoveAtOnce (item lst / lstRet)
	(if lst
		(if (equal item (car lst))
			;擪vfȂ2Ԗڈȍ~Ԃ
			(setq lstRet (cdr lst))
		;else
			;2Ԗڈȍ~̃XgōċA
			(setq lstRet (cons (car lst)(RemoveAtOnce item (cdr lst))))
		)
	)
	lstRet
)

;O[v(ԊÔ)
(defun sk_PeelGroup (sSet / )
	;ԊÕO[v擾
	(setq sPeel (sk_OuterGroupName sSet))

	;Group
	(command "-GROUP" "E" sPeel)
	(princ)
)

;ubN\ǂ
(defun isBlockExplodable (sBlkName / blocks iLen i block sName bRet)
	(setq blocks (vla-get-Blocks (vla-get-ActiveDocument (vlax-get-acad-object))))
	(setq iLen  (vla-get-Count blocks) i 0)
	(while (< i iLen)
		(setq block (vlax-invoke-method blocks 'Item i))
		(setq sName (vla-get-Name block))
		(if (= sName sBlkName)(progn
			(setq bRet (= (vla-get-Explodable block) :vlax-true))
			(setq i iLen)
		))
		(setq i (1+ i))
	)
	bRet
)

;wbNĂ邩
(defun isLayerLocked (sLayer / tblLayer ent bRet)
	(if (setq tblLayer (tblobjname "LAYER" sLayer))(progn
		(setq ent (entget tblLayer))
		(setq iDxf70 (cdr (assoc 70 ent)))
		(setq bRet (= (boole 1 4 iDxf70) 4))
	))
	bRet
)

;ԊÕO[v擾
(defun sk_OuterGroupName (sSet / iLen i enm lstTemp lstGroup lstBase sRet iNumPrev iNum sItem)
	;2023-05-09 WbN(̂)
	;sSet1ڂŔ肷@ɕύX
	(if (< 0 (sslength sSet))(progn
		(setq enmFirst (ssname sSet 0));1

		;1ڂ̐}`O[ṽXg
		(if (setq lstGroup (sk_getGName enmFirst))(progn
			;ꂼ̃O[vɑ}`1ԑ
			(setq iNumPrev 0)
			(foreach sTmp lstGroup
				;sTmpO[vɑ}`List
				(setq lstT (sk_getGroupEnts sTmp))
				(setq iNum (length lstT))
				(if (< iNumPrev iNum)
					(setq sRet sTmp iNumPrev iNum)
				)
			)
		))
	))
	sRet

	;;I}`Q sSet }`̃O[vXg擾
	;;lstGroup = (
	;;             ("sGrp11" "sGrp12" ...)
	;;             ("sGrp21" "sGrp22" ...)
	;;             ............
	;;           )
	;(setq iLen (sslength sSet) i 0)
	;(while (< i iLen)
	;	(setq enm (ssname sSet i))
	;	(setq lstTemp (sk_getGName enm))
	;
	;	;ɓ̂ꍇ͒ǉȂ
	;	(if (and lstTemp (not (member lstTemp lstGroup)))
	;		(setq lstGroup (append lstGroup (list lstTemp)))
	;	)
	;	(setq i (1+ i))
	;)

	;;o񐔂̈ԑOԊO??
	;(setq lstBase (car lstGroup) sRet (car lstBase) iNumPrev 1)
	;(foreach sItem lstBase
	;	(setq iNum 0)
	;	(foreach lstItem lstGroup
	;		(if (member sItem lstItem)
	;			(setq iNum (1+ iNum))
	;		)
	;	)
	;	(if (< iNumPrev iNum)
	;		(setq sRet sItem iNumPrev iNum)
	;	)
	;)
	;sRet
)


;Block --> O[vϊ
(defun sk_BlcToGroup (ssBlock / iLen i el enBlock sBlock sLayer bExplodable bLayerLock)
	(setq iLen (sslength ssBlock) i 0)
	(while (< i iLen)
		(setq enBlock (ssname ssBlock i))
		(setq entBlck (entget enBlock))
		(setq sBlock (cdr (assoc 2 entBlck)))
		(setq sLayer (cdr (assoc 8 entBlck)))

		;\
		(setq bExplodable (isBlockExplodable sBlock))

		;wbN
		(setq bLayerLock (isLayerLocked sLayer))
		(if (and bExplodable (not bLayerLock))(progn
			;
			(setq el (LastEntity))
			(Explode_NestedBlk enBlock)
			(setq ssGroup (Getss el))

			;O[v
			(command "-GROUP" "C" "*" "" ssGroup "")
		))
		(setq i (1+ i))
	)
)



;;----------------------------------------------------------------------------;;
;; gèèްؽĂǉ                                                ;;
;; ename  : (i) }`                                                        ;;
;; apname : (i) عݖ                                                   ;;
;; datlst : (i) ްؽ [ްҰ : (list (cons 1000 "xxx")(1040 xx.yy)...)] ;;
;-----------------------------------------------------------------------------;;
(defun SetXdtLst (ename apname datlst)
	(if ename (progn
		(setq elist (entget ename (list "*")))
		(regapp apname)
		(setq
			xdlst (list '(1002 . "}"))
			xdlst (append datlst xdlst)
			xdlst (cons '(1002 . "{") xdlst)
			xdlst (cons apname xdlst)
			xdlst (list -3 xdlst)
		)
		(setq size_new (xdsize xdlst))
		(if (< size_new (xdroom ename))(progn
			(if (assoc -3 elist)(progn
				(setq xdlst (cdr xdlst))
				(setq xd_ent (cdr (assoc -3 elist)))
				(if (setq old (reverse (cdr (reverse (cddr (assoc apname xd_ent))))))(progn
					(setq new (cddr (assoc apname xdlst)))
					(setq all (append old new))
					(setq xdlst1 (cons (cons 1002 "{") all))
					(setq xdlst2 (cons apname xdlst1))
					(setq xdlst3 (subst xdlst2 (assoc apname xd_ent) (assoc -3 elist)))
				)(progn ;else
					;This is a new regapp...
					;Joins xdata.
					(setq xdlst (append xd_ent xdlst))
					(setq xdlst3 (cons -3 xdlst))
				))

				;Joins entity
				(setq elist (subst xdlst3 (assoc -3 elist) elist))
			);else
				;No xdata yet.
				(setq elist (cons xdlst elist))
			)
		))
		(entmod elist)
	))
)

;;--------------------------------;;
;; gèèްnoԖڂ̎o ;;
;;--------------------------------;;
(defun GetXdt (ename apname no / xd1 xd0 xd ret)
	(if (and ename apname no)(progn
		(if (setq xd0 (assoc -3 (entget ename (list apname))))
			;(if (setq xd (cdr (nth (1+ no) (cadr xd0))))
			(if (setq xd1 (cadr xd0))
				(if (setq xd (cdr (nth (1+ no) xd1)))
					(setq ret xd)
				;else
					(setq ret nil)
				)
			;else
				(setq ret nil)
			)
		;else
			(setq ret nil)
		)
	))
	ret
)

;;------------------------;;
;; gް݂̑𒲂ׂ ;;
;;------------------------;;
(defun isExistXdt (ename apname / ret)
	(setq ret nil)
	(if (and ename apname)
		(if (assoc -3 (entget ename (list apname)))
			(setq ret t)
		)
	)
	ret
)

;;---------------------------------;;
;; gèèް̑S폜()  ;;
;;---------------------------------;;
(defun RemoveXdt (en appName / egl xlst)
	(if en (progn
		(setq egl (entget en))
		(regapp appName)
		(setq xlst (list -3 (list appName)))
		(setq egl (append egl (list xlst)))
		(entmod egl)
	))
)

;;--------------------------------;;
;; gèèްLISTo     ;;
;;--------------------------------;;
(defun GetXdtList (ename apname / xd1 xd0 xd bLoop i lstRet)
	(if (and ename apname)(progn
		(if (setq xd0 (assoc -3 (entget ename (list apname))))
			(if (setq xd1 (cadr xd0))(progn
				(setq bLoop T i 0)
				(while bLoop
					(setq lst (nth (+ i 2) xd1))
					(if (equal lst '(1002 . "}"))
						(setq bLoop nil)
					;else
						(setq lstRet (append lstRet (list lst)))
					)
					(setq i (1+ i))
				)
			);else
				(setq lstRet nil)
			)
		;else
			(setq lstRet nil)
		)
	))
	lstRet
)

;vvgt̒Pw(ssget)
;*** 2021-10-28 ύX (AutoCADɕύX) (acet-ui-single-select)ɃoO? ***
;(acet-ui-single-select)Enter݂̂snilł͂ȂςȐ}`Ԃ̂Ŏgp߂
(defun sk_SingleSsgetWithPrompt (sPrompt / filter bLock en retSs lstGrp sGroup lstEnt enItem bLoop)
;	(if (wcmatch (getvar "ACADVER") "*BricsCAD*")(progn
;		;*** BricsCAD ̏ꍇ ***
;		(setq filter nil bLock T)
;		(prompt sPrompt)
;		(if (setq en (acet-ui-single-select filter bLock))(progn
;			(setq retSs (ssadd en))
;			(setq lstGrp (sk_getGName en))
;			(foreach sGroup lstGrp
;				(if (setq lstEnt (sk_getGroupEnts sGroup))(progn
;					(foreach enItem lstEnt
;						(ssadd enItem retSs)
;					)
;				))
;			)
;		))
;	)(progn
;		;*** AutoCAD ̏ꍇ ***
		(setq bLoop t)
		(while bLoop
			;}`w(}` w_)
			(setvar "ERRNO" 0)
			(prompt sPrompt)
			(setq retSs (ssget ":S"))
			(if (= (getvar "ERRNO") 52)(progn
				; I
				(setq bLoop nil)
				(setq retSs  nil)
			);else
				(if retSs
					(setq bLoop nil)
				)
			)
		)
;	))
	retSs
)

;ss̍ŏ̐}`PƂ̃O[vɑĂ
;̃O[vԂAȊOnilԂB
(defun isSingleGroup (ss / sRet)
	(setq en (ssname ss 0))
	(if en (progn
		(setq lst (sk_getGName en))
		(if (= (length lst) 1)(progn
			(setq sRet (car lst))
		)(progn
			(setq sRet nil)
		))
	))
	sRet
)


;;----------
;;UNDOn܂
;;----------
(defun UndoBegin ()
	(if (= (boole 1 8 (getvar "UNDOCTL")) 8)
		(command "_.UNDO" "E")
	)
	(if (= (boole 1 4 (getvar "UNDOCTL")) 4)
		(command "_.UNDO" "BE")
	)
)


;;----------
;;UNDOI
;;----------
(defun UndoEnd ()
	(if (= (boole 1 8 (getvar "UNDOCTL")) 8)
		(command "_.UNDO" "E")
	)
)

